/*
	Default linker script for MD407 (STM32F407)
	All code and data goes to RAM.
*/

MEMORY
{
  RAM (xrw) : ORIGIN = 0x20000000, LENGTH = 108K
}

SECTIONS
{
     .text :
    {
	. = ALIGN(4);	    
	*(.start_section)	
	*(.text) 			
	*(.data)			
	*(.rodata)  		
    __bss_start = .; 
    *(.bss)	
   __bss_end = .; 
   . = ALIGN(4096); 
   __heap_low = .; 
   . = . + 0x400; 
   __heap_top = .; 
   . = . + 0x400; 
   __stack_top = .;  
   } >RAM
    
 }
