/*
 * 	startup.c
 *
 */
void startup(void) __attribute__((naked)) __attribute__((section (".start_section")) );

void startup ( void )
{
__asm volatile(
	" LDR R0,=0x2001C000\n"		/* set stack */
	" MOV SP,R0\n"
	" BL main\n"				/* call main */
	"_exit: B .\n"				/* never return */
	) ;
}

union float_long
{
    float 	f;
    long 	l;
};


float ultof ( unsigned long a ) /* unsigned long to float */
{
		union float_long fl;
		int exp = 23 + 127;
		if ( a==0 ) 
			return 0.0;	/* Specialfall, måste testas först */
  	
		/* Normalisera */
		while (a & 0xFF000000)
		{ 
			a = a >> 1; 
			exp = exp + 1;
		}
		while ( a < 0x00800000 )
		{
			a  = a << 1; 
			exp = exp - 1;
		}
		/* nollställ implicit inledande etta i mantissan */
		a = a & ~0x00800000 ; 
		
		/* tilldelning till union medlem typ ”long” */
		fl.l = (unsigned long) exp << 23 | a;

		/* returnera som flyttal, teckenbit är 0 */
		return (fl.f);	
}
float sltof ( signed long a ) /* signed long to float */
{
	if ( a < 0) 
		return  -( ultof ( -a ) );
	else 
		return ultof ( a );
}

float f;

void main(void)
{
	f = sltof (-10);
	f = sltof (10);
	f = sltof (-100);
	f = sltof (100);
}

