/*
 * 	libtest.c

 */
#include <libMD407.h>
  
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=__stack_top\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL _crt_init\n");			/* init C-runtime library */
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(" BL _crt_deinit\n");			/* deinit C-runtime library */
__asm__ volatile(" .globl _exit\n");	
__asm__ volatile("_exit: B _exit\n");			/* never return */
}


/* Main program */
void main(void)
{
   printf( "Library test\n");
    /* Raw versions */
	write(STDOUT, "Library test", strlen("Library test\n") );

	char c, buffer[20];
	
	
	write( ASCIIDISPLAY, "TestRad1\n", strlen("TEstRad1\n" ));
	write( ASCIIDISPLAY, "TestRad2", strlen("TestRad2" ));

	
	while( 1 )
	{
		if( read( KEYPAD, buffer, 1))
		{
			c = buffer[0] + '0';
			write( ASCIIDISPLAY, &c, 1);
		}
	}
	
}

