/*
 * 	test_asciidisplay.c
  */
#include <libmd407.h>
  
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=__stack_top\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL _crt_init\n");			/* init C-runtime library */
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(" BL _crt_deinit\n");			/* deinit C-runtime library */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}


/* Main program */
void main(void)
{
	char c;
	while(1){
		(void) read (STDIN_FILENO, &c, 1 );	/* No buffering here ... */
		if( c == '\n' ) break;
		write( ASCIIDISPLAY_FILENO, &c, 1 );
	}
}

