/*
 * 	test_malloc.c
 */
 
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=__stack_top\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL _crt_init\n");			/* init C-runtime library */
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(" BL _crt_deinit\n");			/* deinit C-runtime library */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}


#include <stdlib.h>		/* Deklaration av malloc etc. */

int main(void)
{
   	char str1[]="Beginning of string";
  	char str2[]="Continuation of string";
	char *s1,*s2;
	s1 = malloc( strlen(str1)+1 );
    if( s1 == 0 ) exit(-1);
    strcpy( s1, str1 );
    s2 = realloc( s1, strlen(str1)+ strlen(str2)+1 );
    if( s2 == 0 ) exit(-1);
    strcat( s2,str2 );
	free( s2 );
}
