#include <stdio.h>


void decimal_to_binary(unsigned int dec, char *str)
{
	for( unsigned int mask = 0x80000000; mask != 0; mask >>= 1)
	{
		if( mask & dec)
			*str++ = '1';
		else
			*str++ = '0';
	}
	*str = '\0';
}

void decimal_to_hexadecimal(unsigned int dec, char *str)
{
	unsigned int mask, shifts;
	unsigned char c;
	for( mask = 0xF0000000, shifts=28; mask != 0; mask >>= 4, shifts -= 4)
	{
		c = (mask & dec)>>shifts;
		if( c < 10)
			*str++ = c + '0';
		else
			*str++ = c + 'A' - 10;
	}
	*str = '\0';
}


void pack_date(unsigned int year, unsigned int month, 
unsigned int day, unsigned int *date)
{
	*date= day;
	*date |= (month << 5);
	*date |= (year << 9);
}

void unpack_date(unsigned int date, unsigned int *year, 
  unsigned int *month, unsigned int *day)
{
	  *year = date >> 9;
	  *month = (date >> 5)&0x1F;
	  *day = date & 0xF;
}

unsigned int add_day(unsigned int date, unsigned int day)
{
	
}
unsigned int add_month(unsigned int date, unsigned int month)
{
	
}
unsigned int add_year(unsigned int date, unsigned int year)
{
	
}

int main(void)
{
	unsigned int date,year,month,day;
	while(1)
	{
		pack_date(1956, 8,11, &date);
		printf("%d\n", date);
		unpack_date(date, &year,&month, &day);		
		printf("Year:%d, Month:%d, Day:%d\n", year, month, day);
		
	}
	return 0;
}



int main0(void)
{
	char str[100];
	unsigned int test;
	while(1)
	{
		decimal_to_binary( test, str);
		printf("%s\n", str);
		decimal_to_hexadecimal(test, str);
		printf("%s\n", str);
	}
	return 0;
}
