/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

typedef struct mine_tag
{
	volatile unsigned int cr_SELECT:2;
	volatile unsigned int cr_CNV:1;
	unsigned int :1;
	volatile unsigned int cr_RDY:1;
	unsigned int :2;
	volatile unsigned int cr_LIGHT:3;
	unsigned int :0;
	unsigned int :16;
	volatile unsigned int adc:12;
} MINE_REG;
#define	MINE	(( MINE_REG *) 0xF0000000)

#define	_25PERCENT	(0xFFF>>2)
#define	_50PERCENT	(0xFFF>>1)

void main(void)
{
	unsigned int adc_vals[4];
	
	while(1)
	{
		for( int i = 0; i<4; i++)
		{
			MINE->cr_SELECT = i;
			MINE->cr_CNV = 1;
			while( MINE->cr_RDY = 0 ) ;
			adc_vals[i] = MINE->adc;
		}
		if(    (adc_vals[0] > _50PERCENT )
			&& (adc_vals[1] > _50PERCENT )
			&& (adc_vals[2] > _50PERCENT )
			&& (adc_vals[3] > _50PERCENT ) )
		{
			MINE->cr_LIGHT = 0b100;				
		}else 
		if(    (adc_vals[0] < _25PERCENT )
			&& (adc_vals[1] < _25PERCENT )
			&& (adc_vals[2] < _25PERCENT )
			&& (adc_vals[3] < _25PERCENT ) )
		{
			MINE->cr_LIGHT = 0b010;				
		}else
			MINE->cr_LIGHT = 0b001;				
	}
}

