/*
 * 	startup.c
 *  Anslut GPIO E pin 0-7 till '8 bit dipswitch'
 *  Anslut GPIO D pin 0-7 till '8 segment bargraph'
 *  Anslut GPIO D pin 8-15 till '8 bit dipswitch'
 *  Anslut GPIO D pin 0-7 till '8 segment bargraph'
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

#define	GPIO_D		    0x40020C00
#define	GPIO_MODER 	    ((volatile unsigned int *)	(GPIO_D))  
#define	GPIO_OTYPER 	((volatile unsigned short *)	(GPIO_D+0x4))  
#define	GPIO_PUPDR	    ((volatile unsigned int *)	(GPIO_D+0xC))  
#define	GPIO_IDR_LOW	((volatile unsigned char *)	(GPIO_D+0x10))  
#define	GPIO_IDR_HIGH 	((volatile unsigned char *)	(GPIO_D+0x11))  
#define	GPIO_ODR_LOW	((volatile unsigned char *)	(GPIO_D+0x14))  
#define	GPIO_ODR_HIGH	((volatile unsigned char *)	(GPIO_D+0x15))  

#define USE_ASM
void app_init ( void )
{
#ifdef USE_ASM
__asm__ volatile(" LDR R0,=0x00005555\n");
__asm__ volatile(" LDR R1,=0x40020C00\n");
__asm__ volatile(" STR R0,[R1]\n");

#else 
	*GPIO_MODER = 0x00005555;
#endif
}
void main(void)
{
	char c;
	app_init();
	while(1){
        c = *GPIO_IDR_HIGH ;
        *GPIO_ODR_LOW = c;
	}
 }
