/*
*	libNAME.h
*	Declaration of library functions, constants etc...
*/
#ifndef	_LIBMD407IO_H
#define	_LIBMD407IO_H
typedef struct tag_usart
{
	volatile unsigned short sr;
	volatile unsigned short Unused0;
	volatile unsigned short dr;
	volatile unsigned short Unused1;
	volatile unsigned short brr;
	volatile unsigned short Unused2;
	volatile unsigned short cr1;
	volatile unsigned short Unused3;
	volatile unsigned short cr2;
	volatile unsigned short Unused4;
	volatile unsigned short cr3;
	volatile unsigned short Unused5;
	volatile unsigned short gtpr;
} USART;

#define USART1  ((USART *) 0x40011000)	

void	_outchar( char c );
char	_tstchar( void );
char	_inchar( void );


#include 		<sys/stat.h>
#include		<stdio.h>

int _close(int file);
int _open(const char *name, int flags, int mode);
int _isatty(int file); 
int _fstat(int file, struct stat *st); 
int _lseek(int file, int ptr, int dir);
int _read(int file, char *ptr, int len); 
int _write(int file, char *ptr, int len);
char * _sbrk(int incr);
void 	getline( char *b, int size);

#endif	/* _LIBMD407IO_H */