/*
 * 	test_keypad.c
 */
#include	<stdio.h>
#include	<libmd407.h>
  
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=__stack_top\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL _crt_init\n");			/* init C-runtime library */
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(" BL _crt_deinit\n");			/* deinit C-runtime library */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

static char to_ascii( char c )
{
	if( c < 10 ) return c+'0';
	return (c-10+'A');
}

int main( void )
{
	/* Testapplikationen läser ett tecken från KeyPad
	 * översätter detta till motsvarande ASCII-tecken
	 * och skriver detta till en Terminal
	 */
	 char c;
	 while(1)
	 {
		 read( KEYPAD_FILENO, &c, 1);
		 c = to_ascii( c );
		 fputc( c, stdout );
	 }
}
