/*
 * 	test_usart.c
 */
#include	<stdio.h>
#include	<unistd.h>

  
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=__stack_top\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL _crt_init\n");			/* init C-runtime library */
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(" BL _crt_deinit\n");			/* deinit C-runtime library */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}


void echo_filehandles(void)
{
	/* Läs från konsoll och skriv tillbaks, avsluta vid <CR> */
	char c;
	while(1){
		c = fgetc( stdin );
		fputc( c, stdout );
		if( c == '\n')
			return;
	}
}

void echo_devicehandles(void)
{
	/* Läs från konsoll och skriv tillbaks, avsluta vid <CR> */
	char c;
	while(1){
		(void) read (STDIN_FILENO, &c, 1 );
		(void) write( STDOUT_FILENO, &c, 1 );
		if( c == '\n')
			return;
	}
}

void output(void)
{
	printf( "Hello World 1\n"  );
	fprintf( stdout, "Hello World 2\n" );
	fwrite("Hello World 3\n", 1, 14,stdout);	
	write( STDOUT_FILENO, "Hello World 4\n", strlen("Hello World 4\n" ) );
}

/* Main program */
void main(void)
{
	output();
	echo_filehandles();
	echo_devicehandles();
	printf("Exited\n");
}

