/*
 * goldbach.c
 */
 #include <stdio.h>

int is_prime( int n )
{
	for( int i = n-1; i > 1; i--)
	{
		if( ( n % i)== 0 )
			return 0;
	}
	return 1;
}

int goldbach( int start, int number)
{
	for( int i = start; i<number;i++)
	{
		if( is_prime(i) && is_prime(number-i) )
			return i;
	}
	return 0;
}

int main(int argc, char **argv)
{
	int x,y;
	printf("Goldbach\n");
	while(1)
	{
		printf("Ge ett tal. Avsluta med ett tal <=2:"); 
		scanf("%d",&x); 
		if( x <= 2 ) break;
		if( x%2 )
			printf("%d är ett udda tal\n", x); 
		else
		{
			for( int m = 3; m <= x/2; m++)
			{
				m = goldbach( m, x);
				if(m)
				{
					printf("%d+%d\n", m, x-m ); 
				}else
					break;
			}
		}
	}
	return 0;
}
