/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

// a)
typedef struct lanebrake_tag
{
	volatile unsigned int ASWA:4;
	volatile unsigned int LR:1;
	volatile unsigned int ALW:1;
	unsigned int :3;
	volatile unsigned int ABO:1;
	volatile unsigned int ABW:1;
	volatile unsigned int ABF:1;
	unsigned int :0;
	volatile unsigned int LDD:3;
	unsigned int :4;
	volatile unsigned int LRS:1;
	volatile unsigned int LDW:1;
	unsigned int :1;
	volatile unsigned int LDA:1;
	unsigned int :1;
	volatile unsigned int BRKDA:4;
} LANEBRAKE_REG;
#define	REGBASE	(( LANEBRAKE_REG *) 0xF0000000)

int	main( void) 
{
	if (REGBASE->LDA)
	{
		if( REGBASE->LDW )
			REGBASE->ALW = 1;
		if( REGBASE->LDD > 0 )
		{
			if( REGBASE->LRS)
				REGBASE->LR = 0;
			else
				REGBASE->LR = 1;
		}
	}

	if( REGBASE->ABO)
	{
		if( REGBASE->BRKDA > 7 )
			REGBASE->ABW = 1;
		if( REGBASE->BRKDA == 0xF )
			REGBASE->ABF = 1;
	}
}

